<template>
    <div>
        <div class="uk-flex-center">
            <div v-if="avecSelection">
                <span>Tout sélectionner</span>
                <input
                    class="uk-checkbox"
                    type="checkbox"
                    v-model="checkedAll"
                    @change="checkAll()"
                />
            </div>
        </div>
        <div class="uk-child-width-1-5@m uk-grid-small uk-grid-match" uk-grid>
            <div v-for="problem in problemes" :key="problem.id">
                <router-link
                    tag="div"
                    :to="{
                        name: 'EditionProbleme',
                        params: { idProbleme: problem.id, idLecon: idLecon }
                    }"
                >
                    <div>
                        <div class="uk-padding-small">
                            <img
                                :src="getProblemeImage(problem)"
                                :alt="problem.id"
                                width="230"
                                class="uk-box-shadow-hover-large"
                            />
                        </div>
                    </div>
                </router-link>
                <span class="uk-text-center uk-text-bold">{{
                    problem.titre
                }}</span>
                <span class="uk-flex uk-flex-center"
                    >{{ problem.niveau }}
                    <input
                        class="uk-checkbox"
                        type="checkbox"
                        :value="problem.id"
                        v-if="avecSelection"
                        v-model="problemesCoches"
                        @change="prendreEnCompteProbleme"
                /></span>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Goban from './goban/GobanElementListe.vue';
import Component from 'vue-class-component';
import { Prop } from 'vue-property-decorator';

@Component({
    components: { Goban }
})
export default class ListeProblemes extends Vue {
    @Prop() avecSelection: boolean;
    @Prop() problemes: any[];
    @Prop() idLecon: string;

    private problemesCoches: any[] = [];
    private checkedAll = false;

    public prendreEnCompteProbleme() {
        this.$emit('prendreEnCompteProbleme', this.problemesCoches);
    }

    private getProblemeImage(probleme: Record<string, any>): string {
        return this.$images + 'exercices/' + probleme.id + '.jpg';
    }

    private checkAll() {
        if (this.checkedAll) {
            this.problemesCoches = this.problemes.map(probleme => probleme.id);
        } else {
            this.problemesCoches = [];
        }
        this.prendreEnCompteProbleme();
    }
}
</script>

<style scoped>
.uk-checkbox {
    margin: 3px 3px 3px 8px;
}
</style>
